
%===================================================================================
%Reads the dat-files of VolcFlow
%Rewritten in 2013 for a better compatibility with all the versions of VolcFlow:
%VolcFlow, VolcFlowTsu, VFSurge, etc.
%===================================================================================

%You must modify these lines: <<<<

clear all; clc;
open VFdr_interface.fig %open the interface

%You yould write the name of your input m-file here
cd('F:\VolcFlow\Socompa\')
inputfile='topo_soc2010'; %<<<<    %open the input file of VolcFlow. Do not write .m extension
eval(inputfile)

%You yould write the name of your dat-file here
datfile='F:\effacer.dat';  %<<<<
donnee  = fopen(datfile,'r');
set( findobj('tag', 'Rpinput'), 'string', inputfile);
set( findobj('tag', 'Rfile'), 'string', datfile);

s = dir(datfile);
set( findobj('tag', 'Rdate'), 'string', s.date);
s = dir(strcat(inputfile, '.m'));
set( findobj('tag', 'Rinpdate'), 'string', s.date);

ok=0;

%Reads the header of the dat-file to determine the data that were saved *************************************

nom_lu=''; breakcode=0;
while not(strcmp(nom_lu, '========================================='))
    nom_lu = fscanf(donnee, '%s', 1)
    
    switch(nom_lu)
        case 'input'
            fscanf(donnee, '%s', 2)
            valeur = fscanf(donnee, '%s', 1);
            set( findobj('tag', 'Rinput'), 'string', valeur);
            
        case 'ncol'
            fscanf(donnee, '%s', 1)
            ncol_input = fscanf(donnee, '%d', 1);
            set( findobj('tag', 'Rncol'), 'string', ncol_input);
            if ncol == ncol_input
                set( findobj('tag', 'Rncol'), 'backgroundcolor', [0.9 1 0.9]);
            else
                set( findobj('tag', 'Rncol'), 'backgroundcolor', [1 0.2 0.2]);
                breakcode=1;
            end
            
        case 'nrow'
            fscanf(donnee, '%s', 1)
            nrow_input = fscanf(donnee, '%d', 1);
            set( findobj('tag', 'Rnrow'), 'string', nrow_input);
            if nrow == nrow_input
                set( findobj('tag', 'Rnrow'), 'backgroundcolor', [0.9 1 0.9]);
            else
                set( findobj('tag', 'Rnrow'), 'backgroundcolor', [1 0.2 0.2]);
                %warning('The number of lines differs between the input and the dat files ! ');
                breakcode=1;
            end
            
            
        case 'version'
            fscanf(donnee, '%s', 3)
            version = fscanf(donnee, '%s', 1);
            set( findobj('tag', 'Rversion'), 'string', version);
            
            
        case 'VolcFlow'
            version = fgetl(donnee);
            set( findobj('tag', 'Rversion2'), 'string', version);
            
            
        case 'saved'
            fscanf(donnee, '%s', 2)
            variables = fgetl(donnee);
            set( findobj('tag', 'Rsavvar'), 'string', variables);
            indspace = findstr(variables, ' ');
            for i=1:length(indspace)-1
                var{i} = variables(indspace(i)+1:indspace(i+1)-1);
            end
            %to be continued...
    end
    fgetl(donnee); %reads the rest of the line
end

%These lines break the code if the numbers of lines / columns
%between the present input file and the input file used for the simulation
%are different
if breakcode ==1
    warning('The number of columns and/or columns differs between the present input and the dat files ! ');
    warndlg('The number of columns and/or columns differs between the present input and the dat files ! ');
    return
end

compteur = 0;
uiwait
figure(100)
if ok~=1
    return
end

%Reads the data of the VolcFlow dat-File *************************************

while not(feof(donnee));
    
    fscanf(donnee, '%c', 7);
    t = fscanf(donnee, '%f', 1);
    fprintf('time : %8.2f s\n', t);
    fscanf(donnee, '%c', 1);
    
    if isempty(t)
        return
    end
    
    for i=1:size(var,2) %reads each variables saved h/u/... ---------
        varlue = fread(donnee, ncol*nrow, 'float32');
        varlue = reshape(varlue, nrow,ncol);
        d=sprintf('%s = varlue;', var{i});
        eval(d);
    end
    
    %visualisation of the results -----------------------------
    eval(representation)
    drawnow
    %YOU SHOULD ADD HERE THE LINES THAT WILL ANALYZE THE DATA
    %Visualization, movies, object tracking...
    
end


